/**
 * AutoDAO - Generic DAO on steroids implementation for Java.
 * Copyright (C) 2008  Marat Radchenko <slonopotamus@users.sourceforge.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package net.sf.autodao.hibernate;

import org.springframework.beans.factory.support.BeanDefinitionBuilder;
import org.springframework.beans.factory.xml.AbstractSingleBeanDefinitionParser;
import org.w3c.dom.Element;

/**
 * Processes <code>dao:hibernateFactory</code> elements and builds Spring bean.
 * <p/>
 * NOT FOR PUBLIC USE.
 */
public final class HibernateFactoryBeanDefinitionParser extends AbstractSingleBeanDefinitionParser {

  /** {@inheritDoc} */
  @Override
  protected void doParse(final Element element, final BeanDefinitionBuilder builder) {
    builder
        .addPropertyReference("sessionFactory", element.getAttribute("session-factory"))
        .addPropertyValue("createMissing", element.getAttribute("create-missing"));
  }

  /** {@inheritDoc} */
  @Override
  protected String getBeanClassName(final Element element) {
    return "net.sf.autodao.hibernate.HibernateDaoFactoryImpl";
  }
}
